
# °ִͤΥƥȡAmrita 1.0.2ξϡѥåƤ뤳

require "test/unit"
require "test/unit/ui/console/testrunner"

require "amrita/template"

class AmAttrTest < Test::Unit::TestCase
  # ץִ
  def test10
    tmpl = Amrita::TemplateText.new '<html><input name="@n"></html>'
    model = { :n => "foo" }
    r = ""
    tmpl.expand(r, model)
    assert_equal('<html><input name="foo"></html>', r)
  end

  # Amrita.a()ˤִ
  def test20
    tmpl = Amrita::TemplateText.new '<a id=link>foo</a>'
    model = { :link => Amrita.a(:href => "http://hoge") }
    r = ""
    tmpl.expand(r, model)
    assert_equal('<a href="http://hoge">foo</a>', r)

    # °ͤηURLξϸå
    # ǥǡʸޤޤ硢°ͤ϶ˤʤ
    r = ""
    tmpl.expand(r, {:link => Amrita.a(:href => "<>&'\"")})
    assert_equal('<a href="">foo</a>', r)
  end

  # Amrita.a()ǡ°ͤƤƱִ
  def test21
    tmpl = Amrita::TemplateText.new '<a id=link>foo</a>'
    model = { :link => Amrita.a(:href => "http://foo", :name => "link") {"anchor text"} }

    tmpl.use_compiler = false
    r = ""
    tmpl.expand(r, model)
    assert_equal('<a name="link" href="http://foo">anchor text</a>', r)

    tmpl.use_compiler = true
    r = ""
    tmpl.expand(r, model)
    assert_equal('<a name="link" href="http://foo">anchor text</a>', r)
  end

  # ҤˤʤäǤΤǤ°Τִ
  # Amrita.a()
  def test25
    tmpl = Amrita::TemplateText.new("<tr id=r><td id=a>foo<td id=r>bar</tr>")
    model = {
      :r => {:r => Amrita.a(:a => "hoge") {"text"} } }

    r = ""
    tmpl.expand(r, model)
    assert_equal('<tr><td a="hoge">text</td></tr>', r)
  end

  # Amrita.a()Ǥϡ֥åȤʸ󤷤ʤ
  # @nameǽ˻ꤹ
  def test26
    tmpl = Amrita::TemplateText.new(
                    '<tr style="@s"><td id=a>foo<td id="in" style="@s">bar</tr>')
    model_a = {
      :s => "font:hoge" }
    model_b = {
      :in => {:s => "font:bar"} }

    r = ""
    tmpl.expand(r, model_a)
    assert_equal('<tr style="font:hoge"></tr>', r)

    r = ""
    tmpl.expand(r, model_b)
    assert_equal('<tr><td style="font:bar">bar</td></tr>', r)
  end
end

if __FILE__ == $0
  Test::Unit::UI::Console::TestRunner.run(AmAttrTest)
end
